/*
  ______   ______   _    _  _        _  _     
 (_____ \ (_____ \ | |  / )| |      (_)| |    
  _____) ) _____) )| | / / | |       _ | | _  
 (_____ ( |  ____/ | |< <  | |      | || || \ 
       | || |      | | \ \ | |_____ | || |_) )
       |_||_|      |_|  \_)|_______)|_||____/ 
                                              

                      - Version 0.1 -
                                             RedKod Team
                                           www.redkod.com
Coder: R-e-D
Mail : r-e-d@redkod.com

Packets forging library designed for NT System.
Copyright (C) 2002 R-e-D

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef _PACKETS_
#define _PACKETS_

typedef struct iphdr
{
    unsigned char  verlen;
    unsigned char  tos;           
    unsigned short tot_len;       
    unsigned short id;            
    unsigned short offset;        
    unsigned char  ttl;           
    unsigned char  protocol;      
    unsigned short checksum;      
    unsigned int   saddr;         
    unsigned int   daddr;     
} IP_HDR;

typedef struct tcphdr
{
	unsigned short	sport;
	unsigned short	dport;
	unsigned int	seqnum;
	unsigned int	acknum;
	unsigned char	DataOffset;
	unsigned char	Flags;
	unsigned short	Window;
	unsigned short	Checksum;
	unsigned short	UrgPointer;
} TCP_HDR;

typedef struct icmphdr
{
	unsigned char  type;
	unsigned char  code;
	unsigned short checksum; 
	unsigned short id;
	unsigned short seq;
	unsigned long  timestamp;
} ICMP_HDR; 

typedef struct udphdr
{
	unsigned short srcport; 
	unsigned short dstport; 
	unsigned short length; 
	unsigned short checksum; 
} UDP_HDR;


/* pseudo en-tete ncessaire au calcul du checksum */
struct pseudohdr
{
	    unsigned long saddr;
	    unsigned long daddr;
	    char useless;
	    unsigned char protocol;
	    unsigned short length;
	    struct tcphdr tcp;
};


#endif